/*global cc*/
/*global require*/

require( "src/Animation/PositionAnimator.js" );
/*global PositionAnimator*/

require( "src/Animation/LayoutLoader.js" );
/*global LayoutLoader*/

var FramePositionAnimator;
(function()
{
    "use strict";
    
    FramePositionAnimator = PositionAnimator.extend(
    {
        /** @lends FramePositionAnimator.prototype */
        
        /**
         * An FramePositionAnimator will animate position changes on a node.
         * Use this for legacy animations, which animate using bounding boxes (frames).
         *
         * @constructs
         */
        ctor: function( globalSizeChange, globalScale )
        {
            this._super( globalSizeChange, globalScale );
        },
        
        _convertDesignValueToGameValue: function( designValue, node )
        {
            return LayoutLoader.convertDesignPointToWorldPoint( node, designValue, designValue, this.globalSizeChange, this.globalScale );
        }
    });
}() );