/*global cc*/
/*global require*/

require( "src/Animation/PropertyAnimator.js" );
/*global PropertyAnimator*/

require( "src/Animation/LayoutLoader.js" );
/*global LayoutLoader*/

var PositionAnimator;
(function()
{
    "use strict";
    
    PositionAnimator = PropertyAnimator.extend(
    {
        /** @lends PositionAnimator.prototype */
        
        /**
         * An PositionAnimator will animate position changes on a node.
         * An important note: this is for use with non-Legacy animations.
         *
         * @constructs
         */
        ctor: function( globalSizeChange, globalScale )
        {
            this._super( "MoveTo" );
            
            this.globalSizeChange = globalSizeChange;
            this.globalScale = globalScale;
        },
        
        _convertDesignValueToGameValue: function( designValue, node )
        {
            return LayoutLoader.convertDesignPointToWorldPoint( node, designValue, undefined, this.globalSizeChange, this.globalScale );
        },
        
        _setFunction: function( node, value )
        {
            node.setPosition( value );
        }
    });
}() );