/*global require*/
/*global cc*/
/*global LumosityUtils*/

require( "src/Utility/LumosityUtils.js" );

var LumosityAspectNode;
( function()
{
    "use strict";

    LumosityAspectNode = cc.Node.extend(
    {
        isScaleToMin: true,

        _initialScale: cc.p( 1, 1 ),

        /** @lends LumosityAspectNode.prototype */
        
        ctor: function( scaleToMin )
        {
            this._super();
            this.isScaleToMin = scaleToMin;
        },

        onEnter: function()
        {
            var uniformScale = cc.PointZero();
            var newScale = cc.p( 1, 1 );

            this._super();

            this._initialScale = cc.p( this.getScaleX(), this.getScaleY() );
            uniformScale = LumosityUtils.getNodeHierarchyUniformScale( this, this.isScaleToMin );
            newScale = cc.p( this._initialScale.x * uniformScale.x, this._initialScale.y * uniformScale.y );

            this.setScaleX( newScale.x );
            this.setScaleY( newScale.y );
        },

        onExit: function ()
        {
            this._super();

            this.setScaleX( this._initialScale.x );
            this.setScaleY( this._initialScale.y );
        }
    } );
}() );