// Generated by CoffeeScript 1.7.1
(function() {
  var ChalkboardChallengeModel, ChalkboardChallengeSettings, ChalkboardChallengeView, IntegerRange, ValueRecipe, audio, cc, failCount, getTime, ip, it, rrange, tt,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.require('src/Game/Base/Game.js');

  this.require('src/Game/ChalkboardChallengeSettings.js');

  this.require('src/Game/ChalkboardChallengeModel.js');

  this.require('src/Game/ChalkboardChallengeView.js');

  cc = this.cc;

  ChalkboardChallengeSettings = this.ChalkboardChallengeSettings;

  ChalkboardChallengeModel = this.ChalkboardChallengeModel;

  ChalkboardChallengeView = this.ChalkboardChallengeView;

  tt = this.ChalkboardChallengeUtil;

  audio = cc.AudioEngine.getInstance();

  it = this.InteractionType;

  ip = this.InteractionPhase;

  getTime = function() {
    return (new Date()).getTime() * 0.001;
  };

  rrange = function(lo, hi) {
    return Math.floor(lo + Math.random() * (hi - lo));
  };

  IntegerRange = (function() {
    function IntegerRange(min, max) {
      this.min = Math.floor(min);
      this.max = Math.floor(max);
      this.valid = this.min !== -1 && this.max !== -1;
    }

    IntegerRange.prototype.containsValue = function(value) {
      return value >= this.min && value <= this.max;
    };

    IntegerRange.prototype.getRandomContainedValue = function() {
      if (this.min === this.max) {
        return this.min;
      } else {
        return rrange(this.min, this.max + 1);
      }
    };

    IntegerRange.prototype.constrainTo = function(constrainMin, constrainMax) {
      this.min = this.min < constrainMin ? constrainMin : this.min;
      return this.max = this.max > constrainMax ? constrainMax : this.max;
    };

    return IntegerRange;

  })();

  ValueRecipe = (function() {
    function ValueRecipe(operatorString, rangeOrValueList) {
      this.operatorString = operatorString;
      if (rangeOrValueList instanceof Array) {
        this.valueList = rangeOrValueList;
      } else {
        this.range = rangeOrValueList;
      }
    }

    ValueRecipe.prototype.getValueList = function() {
      return this.valueList;
    };

    ValueRecipe.prototype.getOperator = function() {
      return this.operatorString;
    };

    ValueRecipe.prototype.getRange = function() {
      return this.range;
    };

    ValueRecipe.prototype.hasRange = function() {
      return 'range' in this;
    };

    ValueRecipe.prototype.hasValueList = function() {
      return 'valueList' in this;
    };

    return ValueRecipe;

  })();

  failCount = 0;

  this.ChalkboardChallenge = (function(_super) {
    __extends(ChalkboardChallenge, _super);

    function ChalkboardChallenge()
    {
      ChalkboardChallenge.__super__.constructor.apply(this, arguments);
      this.configureMetaDataKeys();
    }

    ChalkboardChallenge.prototype._createSettings = function() {
      return new ChalkboardChallengeSettings();
    };

    ChalkboardChallenge.prototype._createModel = function() {
      return new ChalkboardChallengeModel(this.settings);
    };

    ChalkboardChallenge.prototype._createView = function(screenSize) {
      return new ChalkboardChallengeView(screenSize, this.settings, this.model, this);
    };

    // Extends Game._createComponents
    ChalkboardChallenge.prototype._createComponents = function()
    {
      ChalkboardChallenge.__super__._createComponents.call( this );
      if( this.settings.showTime === true )
      {
        if( LumosityUtils.isFitTestModeOn() )
        {
          timer = this._components.GameComponentTimer;
          if( timer === undefined )
          {
            this._addComponent( new GameComponentTimer( this ) );
          }
        }
      }
    };

    // Wraps Game.onBegin with fit test logic to show how to play slides
    ChalkboardChallenge.prototype.onBegin = function()
    {
      // IVY: For the first pass at the fit test tutorial, we want to just show the how to play slides
      // Circumventing the shared logic a bit to support.
      if( LumosityUtils.isFitTestModeOn()
        && this.model.fitTestDidOpenHowToPlayOnStart !== true)
      {
        // Prevent circular logic when onBegin is called after PLAY is pressed in the how to play slides
        this.model.fitTestDidOpenHowToPlayOnStart = true;

        // Ensure that howToPlay_playNowTapped and howToPlay_backNowButtonTapped emulates the same behavior as
        // "how to play non-fit test" games, which makes the X button quit the game, and the PLAY button call onBegin
        this.model.isOnBeginCalled = false;

        this.model.restartToPracticeMode = false; // Show countdown on first play
        this.model.isFitTestMode = true; // Show the normal hud, with time and score
        this.model.tutorialEnded = true; // Set restartToFitTestMode to true, which makes restart show the right hud

        // Show the how to play slides instantly if we are just starting the fit test.
        // Otherwise, transition nicely if the player hit Restart from the pause menu.
        // this.view.forceStopTransition();
        var doInstantly = ( this.model.persistentData.num_restart === 0);
        this.showHowToPlay( doInstantly );
      }
      else // Normal gameplay flow. Also called after the how to play slides are closed in fit test mode
      {
        if( LumosityUtils.isFitTestModeOn() )
        {
          this.model.restartToPracticeMode = false; // Show countdown on first play
          this.model.isFitTestMode = true; // Show the normal hud, with time and score
          this.model.tutorialEnded = true; // Set restartToFitTestMode to true, which makes restart show the right hud
        }

        ChalkboardChallenge.__super__.onBegin.call( this );
        this.model.score = 0;
        this.view.setScore( 0 );
        this.view.setStreakNumber( 0 );
        this.view.setLevel( 1 );
        this.view.resetTextColor();
        this.model.levelNumber = 0;
        this.view.enableButtons( false );
      }
    };

    // Replaces Game.onRestart
    ChalkboardChallenge.prototype.onRestart = function()
    {
      this.model.persistentData.num_restart++;
      var restartToFitTestMode = false;
      // Undo this comment and comment out the line below it to restart to fitTest mode.
      // rather than restarting to the tutorial.
      // if ( LumosityUtils.isFitTestModeOn() && !this.model.restartToPracticeMode )
      if( LumosityUtils.isFitTestModeOn() && this.model.tutorialEnded )
      {
        restartToFitTestMode = true;
        this.model.tutorialEnded = false;
      }

      var tutorialPopUpPlaying = this.view.guidedEndPopUpPlaying ? true : false;

      // store off Persistent data
      var persistentData = this.model.persistentData;
      //create a brand new model
      this.model = this._createModel();
      this.model.persistentData = persistentData;
      this.view.model = this.model;

      if( LumosityUtils.isFitTestModeOn() )
      {
        if( restartToFitTestMode )
        {
          this.model.isFitTestMode = true;
          this.model.shouldCreateTimer = true;
          this.model.restartToPracticeMode = false;
          this.model.persistentData.isPracticeMode = false;
        }
        else
        {
          // Restarts tutorial metaData
          this.tutorialMetadata = {
            _incongruentStimuliCorrect: 0,
            _trialCongruentTimes: [],
            _trialIncongruentTimes: [],
            _trialIncorrectTimes: [],
            _trialCorrectTimes: [],
            _trialResponseTimes: [],
            _trialSwitchTimes: [],
            _trialNoSwitchTimes: [],
            starts: this.tutorialMetadata.starts,
            finishes: this.tutorialMetadata.finishes,
            correct: 0, incorrect: 0,
            time: 0,
            _trials: []
          };
          this.model.shouldCreateTimer = false;
          this.view.removeDimLayer();
          if( tutorialPopUpPlaying )
          {
            this.view.removeFrontDimLayer();
          }
          this.model.restartToPracticeMode = true;
        }
      }

      //re-create all our components
      this._components = {};
      this._createComponents();

      //have the view restart itself
      this.view.onRestart();

      // IVY: For the first pass at the fit test tutorial, we want to just show the how to play slides
      // Circumventing the shared logic a bit to support.
      // Copied onRestart function from base class to prevent this.view.centerOnGameStage() from getting called if we 
      // want to call this.showHowToPlay( doInstantly ) in onBegin instead
      if( !( LumosityUtils.isFitTestModeOn() ) )
      {
        // In normal gameplay or how to play
        //and transition back from the pause menu
        this.view.centerOnGameStage();
      }

      //now begin the game again
      this.onBegin();
    };

    ChalkboardChallenge.prototype.onStartGameplay = function() {
      ChalkboardChallenge.__super__.onStartGameplay.call(this);
      this.view.enableButtons(true);
      this.model.lastAnswerTime = getTime();
      this.startNewTrial();
      this.view.onGameBeginAnimationFinished();
      return this.view.playAnimation("showHintText");
    };

    ChalkboardChallenge.prototype.onUpdate = function(dt) {
      ChalkboardChallenge.__super__.onUpdate.call(this, dt);
      return this.view.tickFeedbackAnimation(dt);
    };

    ChalkboardChallenge.prototype.onComponentTimerEnd = function() {
      this.view.setAnswers("", "");
      this.view.prompt.setVisible(false);
      return ChalkboardChallenge.__super__.onComponentTimerEnd.call(this);
    };

    ChalkboardChallenge.prototype.onFinishGameplay = function() {
      var anim, _i, _len, _ref;
      this.model.finishCurrentTrial();
      this.model.isBlockingInput = true;
      this.view.fadeOutStimuli(0.3);
      _ref = ['incorrect0', 'feedback1', 'feedback2', 'feedback3', 'feedback4', 'feedback5', 'answerBonus'];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        anim = _ref[_i];
        this.view.stopAnimation(anim);
      }
      this.view.hideFeedback();
      this.view.setStreakNumber(0);
      this.view.setWhichIsLargerVisible(false);
      this.view.enableButtons(false);
      return ChalkboardChallenge.__super__.onFinishGameplay.call(this);
    };

    ChalkboardChallenge.prototype._buttonPressed = function(name) {
      ChalkboardChallenge.__super__._buttonPressed.call(this, name);
      if (!this.model.isGameRunning || this.model.isBlockingInput) {
        return;
      }
      switch (name) {
        case "buttonLeft":
          return this.factorInput(-1);
        case "buttonRight":
          return this.factorInput(1);
        case "buttonEqual":
          return this.factorInput(0);
      }
    };

    ChalkboardChallenge.prototype.factorInput = function(comparison) {
      var diff, trialMetadata;
      if (!this.model.isGameRunning || this.model.isBlockingInput) {
        return;
      }
      this.view.enableButtons(false);
      // trialMetadata = this.model.getCurrentChalkboardChallengeGameResultTrialMetadata();
      // if (trialMetadata) {
      //   trialMetadata.setUserAnswer(trialMetadata.getComparisonSignFromDiff(comparison));
      // }

      this.model.currentTrial[ metadataTrialKeys.got ]  = this._formatComparisonForMetadata( comparison );

      diff = this.model.rightValue - this.model.leftValue;
      if (diff === 0) {
        return this.factorResults(comparison === 0);
      } else if (diff < 0) {
        return this.factorResults(comparison < 0);
      } else {
        return this.factorResults(comparison > 0);
      }
    };

    ChalkboardChallenge.prototype.factorResults = function(success) {
      var isBonus, now, pointDelta, reactionTime, scoreMultiplier, timeAdded, timer, trialMetadata;
      if (LumosityUtils.isDebugModeOn()) {
        success = true;
      }
      pointDelta = 0;
      timeAdded = 0;
      this.model.totalResponses += 1;
      this.model.isBlockingInput = true;
      this.model.lastAnswerWasCorrect = success;
      if (success) {
        this.model.setConsecutiveCorrectCount(this.model.consecutiveCorrectCount + 1);
        this.model.streakCount = this.model.streakCount + 1;
        scoreMultiplier = this.settings.pointMultipliers[this.model.levelNumber];
        pointDelta = Math.floor(this.settings.pointsPerCorrect * scoreMultiplier);
        isBonus = this.model.streakCount >= this.settings.consecutiveCorrectCountForLevelIncrease;
        now = getTime();
        reactionTime = now - this.model.lastAnswerTime;
        this.model.setAverageReactionTime(this.model.averageReactionTime * (1.0 - 1.0 / this.model.totalResponses) + reactionTime * (1.0 / this.model.totalResponses));
        this.model.lastAnswerTime = now;
        this.model.totalCorrectResponses += 1;
        this.view.showFeedback(true, Math.floor(scoreMultiplier), isBonus, isBonus);
        this.view.chalkboardTimeBonus.setString("+" + this.settings.secondsAddedOnNewLevel + " seconds");
        cc.log("PLAY FEEDBACK " + this.model.streakCount);
        this.view.playFeedbackAnimation(this.model.streakCount);
        if (isBonus) {
          this.model.streakCount = 0;
          this.model.levelNumber = this.model.levelNumber + 1;
          if (this.model.levelNumber >= this.settings.getLevelCount()) {
            this.model.levelNumber = this.settings.getLevelCount() - 1;
          }
          timer = this._components.GameComponentTimer;
          if (this.model.timeRemaining <= this.settings.secondsRemainingForShaking) {
            timer._timeRemaining = this.settings.secondsRemainingForShaking + this.settings.secondsAddedOnNewLevel;
          } else {
            timer._timeRemaining = this.model.timeRemaining + this.settings.secondsAddedOnNewLevel;
          }
          this.view.setLevel(this.model.levelNumber + 1);
          timeAdded = Math.floor(this.settings.secondsAddedOnNewLevel);
          this.view.setExtraTimeChange(timeAdded);
        }
        this.view.playAnimation("problemSolvedCorrect");
      } else {
        pointDelta = this.settings.pointsPerIncorrect;
        this.model.setConsecutiveCorrectCount(0);
        this.view.showFeedback(false);
        if (this.model.streakCount === 0) {
          this.view.playAnimation("incorrect0");
        } else {
          this.model.streakCount = this.model.streakCount - 1;
          this.view.chalkboardTimeBonus.setString("" + this.settings.secondsAddedOnIncorrect + " seconds");
          this.view.playFeedbackAnimation(this.model.streakCount);
        }
        timer = this._components.GameComponentTimer;
        if (this.model.timeRemaining > this.settings.secondsRemainingForShaking) {
          timer._timeRemaining = this.model.timeRemaining + this.settings.secondsAddedOnIncorrect;
          if (timer._timeRemaining < 0) {
            timer._timeRemaining = 0;
          }
          if (this.model.timeRemaining < this.settings.secondsRemainingForShaking) {
            timer._timeRemaining = this.settings.secondsRemainingForShaking;
          }
        } else {
          timer._timeRemaining = 0;
        }
        timeAdded = Math.floor(this.settings.secondsAddedOnIncorrect);
        this.view.setExtraTimeChange(timeAdded);
        this.view.playAnimation("problemSolvedIncorrect");
        this.view.setAnswers("" + this.model.leftValue, "" + this.model.rightValue);
      }
      this.model.score = this.model.score + pointDelta;
      this.view.setScore(this.model.score);
      // trialMetadata = this.model.getCurrentChalkboardChallengeGameResultTrialMetadata();
      // if (trialMetadata) {
      //   trialMetadata.setCorrect(success);
      //   trialMetadata.setTimeAdded(timeAdded * 1000);
      // }

      this.model.currentTrial[ metadataTrialKeys.correct ]    = ( success === true ) ? "T" : "F";
      this.model.currentTrial[ metadataTrialKeys.timeAdded ] = timeAdded * 1000;

      this.endTrial( this.model.currentTrial, success, false, false, false );

      return this.model.finishCurrentTrial();
    };

    ChalkboardChallenge.prototype.animationFinished_problemSolvedCorrect = function() {
      if (!this.model.isGameRunning) {
        return;
      }
      return this.startNewTrial();
    };

    ChalkboardChallenge.prototype.animationFinished_problemSolvedIncorrect = function() {
      if (!this.model.isGameRunning) {
        return;
      }
      this.view.setTextAccent(false);
      return this.startNewTrial();
    };

    ChalkboardChallenge.prototype.animationFinished_feedback5 = function() {
      this.view.enableButtons(true);
      return this.view.playAnimation("answerBonus");
    };

    ChalkboardChallenge.prototype.cue_dotChange1 = function() {
      if (this.model.timeRemaining > 0) {
        return this.view.setStreakNumber(1);
      }
    };

    ChalkboardChallenge.prototype.cue_dotChange2 = function() {
      if (this.model.timeRemaining > 0) {
        return this.view.setStreakNumber(2);
      }
    };

    ChalkboardChallenge.prototype.cue_dotChange3 = function() {
      if (this.model.timeRemaining > 0) {
        return this.view.setStreakNumber(3);
      }
    };

    ChalkboardChallenge.prototype.cue_dotChange4 = function() {
      if (this.model.timeRemaining > 0) {
        return this.view.setStreakNumber(4);
      }
    };

    ChalkboardChallenge.prototype.cue_dotChange5 = function() {
      if (this.model.timeRemaining > 0) {
        return this.view.setStreakNumber(5);
      }
    };

    ChalkboardChallenge.prototype.cue_hideDot4 = function() {
      return this.view.setStreakNumber(4);
    };

    ChalkboardChallenge.prototype.cue_hideDot3 = function() {
      return this.view.setStreakNumber(3);
    };

    ChalkboardChallenge.prototype.cue_hideDot2 = function() {
      return this.view.setStreakNumber(2);
    };

    ChalkboardChallenge.prototype.cue_hideDot1 = function() {
      return this.view.setStreakNumber(1);
    };

    ChalkboardChallenge.prototype.cue_hideDot0 = function() {
      return this.view.setStreakNumber(0);
    };

    ChalkboardChallenge.prototype.cue_timeHudHighlight = function() {
      return this.view.setHighlightedTimeHud(true);
    };

    ChalkboardChallenge.prototype.cue_timeHudNormal = function() {
      return this.view.setHighlightedTimeHud(false);
    };

    ChalkboardChallenge.prototype.cue_swapImage = function() {
      return this.view.setTextAccent(true);
    };

    ChalkboardChallenge.prototype.configureMetaDataKeys = function()
    {
        ChalkboardChallenge.__super__.configureMetaDataKeys.call( this );

        metadataTrialKeys.correct           = "correct";            // Was the trial correctly answered? (T/F)
        metadataTrialKeys.level             = "level";              // Level
        metadataTrialKeys.equation          = "equation";           // Equations given, delimited by semicolon
        metadataTrialKeys.expected          = "expected";           // The correct answer [<,>,=]
        metadataTrialKeys.got               = "got";                // The given answer [<,>,=]
        metadataTrialKeys.responseTime      = "response_time";      // Response time (ms) (**earlier version reported microseconds)
        metadataTrialKeys.timeAdded         = "time_added";         // Time added in milliseconds
        metadataTrialKeys.inputType         = "input_type";         // "L" if a,w,s,d was used for input, "R" if the arrows were used for input [Not applicable in the mobile version]
        metadataTrialKeys.progress          = "progress";           // Multiplier pips

        cc.log( "metadataTrialKeys: " + JSON.stringify( metadataTrialKeys ) );
    };

    ChalkboardChallenge.prototype.startNewTrial = function() {
      var attempts, rand, trialMetadata;

      // Create and begin a new trial.
      this.beginTrial();
      this.model.currentTrial = {};

      this.model.startNextTrial();
      this.model.isBlockingInput = false;
      this.view.enableButtons(true);
      rand = Math.random();
      if (rand <= this.settings.trialTypeGreaterThanChance) {
        this.model.trialType = "greaterThan";
      } else if (rand <= this.settings.trialTypeGreaterThanChance + this.settings.trialTypeLessThanChance) {
        this.model.trialType = "lessThan";
      } else {
        this.model.trialType = "equals";
      }
      cc.log("TRIAL TYPE: " + this.model.trialType);
      attempts = 0;
      while (!this.generateNewProblems()) {
        if (attempts >= 100) {
          cc.log("ERROR: Tried too many times to create a problem - giving up");
          this.model.setLeftValue(rrange(this.settings.getMinimumAddSubtractValue(), this.settings.maximumValue));
          this.model.setRightValue(rrange(this.settings.getMinimumAddSubtractValue(), this.settings.maximumValue));
          this.model.leftEquation = "" + this.model.leftValue;
          this.model.rightEquation = "" + this.model.rightValue;
          break;
        }
        attempts += 1;
      }
      if (!this.view.playAnimation("problem")) {
        this.view.showStimuliImmediately();
      }
      this.view.showNewValue(this.model.leftEquation, this.model.rightEquation);
      //trialMetadata = this.model.getCurrentChalkboardChallengeGameResultTrialMetadata();

      // if (trialMetadata) {
      //   trialMetadata.setLevel(this.model.levelNumber);
      //   trialMetadata.setEquation("" + this.model.leftEquation + ":" + this.model.rightEquation);
      //   return trialMetadata.setExpectedAnswer(trialMetadata.getComparisonSignFromDiff(this.model.rightValue - this.model.leftValue));
      // }

      // Log Metadata.
      this.model.currentTrial[ metadataTrialKeys.level ]    = this.model.levelNumber;
      this.model.currentTrial[ metadataTrialKeys.equation ] = ("" + this.model.leftEquation + ";" + this.model.rightEquation).replace(/ /g,'').replace(this.settings.operatorRegExp, (function(x) {return this.settings.operatorToANSI[x]}).bind(this));
      this.model.currentTrial[ metadataTrialKeys.expected ] = this._formatComparisonForMetadata( ( this.model.rightValue - this.model.leftValue ) );
      this.model.currentTrial[ metadataTrialKeys.progress ] = this.model.streakCount;
    };

    ChalkboardChallenge.prototype._formatComparisonForMetadata = function( value )
    {
        var formatedComparison = "Invalid";

        if( value < 0 )
        {
            formatedComparison = "<";
        }
        else if( value === 0 )
        {
            formatedComparison = "=";
        }
        else if( value > 0 )
        {
            formatedComparison = ">";
        }

        return formatedComparison;
    };

    ChalkboardChallenge.prototype.generateNewProblems = function() {
      var diff, leftEquation, leftRange, leftValue, level, rightEquation, rightRange, rightValue, success, _ref, _ref1;
      level = this.settings.getLevelAt(this.model.levelNumber);
      leftRange = new IntegerRange(level.getMaximumDifference() + 1, this.settings.maximumValue);
      _ref = this.generateProblem(leftRange, this.calculateOperatorCount(level, true, this.model.streakCount)), success = _ref[0], leftEquation = _ref[1], leftValue = _ref[2];
      if (!success) {
        return false;
      }
      rightRange = new IntegerRange(leftRange.min, leftRange.max);
      if (this.model.trialType === "greaterThan") {
        diff = rrange(0, level.getMaximumDifference());
        rightRange.min = Math.ceil(leftValue - diff - 1);
        rightRange.max = leftValue - 1;
      } else if (this.model.trialType === "lessThan") {
        diff = rrange(0, level.getMaximumDifference());
        rightRange.min = leftValue + 1;
        rightRange.max = Math.floor(leftValue + diff + 1);
      } else {
        rightRange.min = leftValue;
        rightRange.max = leftValue;
      }
      rightRange.constrainTo(1, leftRange.max);
      _ref1 = this.generateProblem(rightRange, this.calculateOperatorCount(level, false, this.model.streakCount)), success = _ref1[0], rightEquation = _ref1[1], rightValue = _ref1[2];
      if (!success) {
        return false;
      }
      if (leftEquation === rightEquation) {
        return false;
      }
      if (this.model.leftEquation === leftEquation && this.model.rightEquation === rightEquation) {
        return false;
      }
      this.model.leftEquation = leftEquation;
      this.model.setLeftValue(leftValue);
      this.model.rightEquation = rightEquation;
      this.model.setRightValue(rightValue);
      return true;
    };

    ChalkboardChallenge.prototype.generateProblem = function(range, operatorCount) {
      var equation, i, opCount, opKey, opText, opVisual, operands, operators, success, value, _i, _len;
      equation = "";
      value = range.getRandomContainedValue();
      operators = [];
      operands = [];
      success = this.generateProblemHelper(operators, operands, value, operatorCount);
      if (success) {
        opKey = this.settings.getLevelAt(this.model.levelNumber).getOperatorKey();
        opCount = this.settings.getOperatorCount(opKey);
        equation = opCount === 0 ? "" + operands[0] : "" + operands[0] + " ";
        for (i = _i = 0, _len = operators.length; _i < _len; i = ++_i) {
          opText = operators[i];
          opVisual = this.settings.operatorToVisual[opText];
          equation += "" + opVisual + " " + operands[i + 1];
          if (i < operatorCount - 1) {
            equation = "(" + equation + ") ";
          }
        }
      }
      return [success, equation, value];
    };

    ChalkboardChallenge.prototype.generateProblemHelper = function(operators, operands, value, operatorCount) {
      var firstOperand, firstOperator, potentialOperand, potentialOperator, potentialValue, recipes, success, _ref;
      if (failCount > 10) {
        cc.log("fail fail");
      }
      if (operatorCount > 0) {
        recipes = this.generateValueRecipes(value, operatorCount);
        _ref = this.chooseOperation(recipes, value), success = _ref[0], potentialOperator = _ref[1], potentialOperand = _ref[2], potentialValue = _ref[3];
        if (success) {
          operators.unshift(potentialOperator);
          operands.unshift(potentialOperand);
          failCount += 1;
          return this.generateProblemHelper(operators, operands, potentialValue, operatorCount - 1);
        } else {
          if (operators.length <= 0) {
            cc.log("Failed to create problem!");
            failCount = 0;
            return false;
          } else {
            firstOperator = operators.shift();
            firstOperand = operands.shift();
            failCount += 1;
            return this.generateProblemHelper(operators, operands, this.performOperationFromString(value, firstOperator, firstOperand), operatorCount + 1);
          }
        }
      } else {
        operands.unshift(value);
        failCount = 0;
        return true;
      }
    };

    ChalkboardChallenge.prototype.generateValueRecipes = function(value, operatorCount) {
      var addRange, divRange, i, mulRange, op, opKey, recipes, subRange, _i, _ref;
      addRange = new IntegerRange(1, this.settings.maximumValue);
      subRange = new IntegerRange(1, this.settings.maximumValue);
      mulRange = new IntegerRange(2, Math.round(value / 2.0));
      divRange = new IntegerRange(1, this.settings.maximumValue);
      opKey = this.settings.getLevelAt(this.model.levelNumber).getOperatorKey();
      recipes = [];
      for (i = _i = 0, _ref = this.settings.getOperatorCount(opKey) - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; i = 0 <= _ref ? ++_i : --_i) {
        op = this.settings.getOperatorAt(opKey, i);
        if (op === "+" || op === "-" || op === "x" || op === "/") {
          recipes.push(new ValueRecipe(op, (function() {
            switch (op) {
              case "+":
                return this.findAddRange(value, addRange);
              case "-":
                return this.findSubRange(value, subRange);
              case "x":
                return this.findValidMultCandidates(value, mulRange);
              case "/":
                return this.findDivRange(value, divRange);
            }
          }).call(this)));
        }
      }
      return recipes;
    };

    ChalkboardChallenge.prototype.chooseOperation = function(recipes, value) {
      var divideIndex, i, index, operand, operatorString, potential, potentials, recipe, reverseValue, _i, _j, _len, _len1;
      operatorString = "";
      operand = 0;
      reverseValue = 0;
      potentials = [];
      for (_i = 0, _len = recipes.length; _i < _len; _i++) {
        recipe = recipes[_i];
        if (recipe.hasRange() && recipe.getRange().valid) {
          potentials.push(recipe);
        } else if (!recipe.hasRange() && recipe.getValueList().length > 0) {
          potentials.push(recipe);
        }
      }
      if (potentials.length > 0) {
        divideIndex = -1;
        for (i = _j = 0, _len1 = potentials.length; _j < _len1; i = ++_j) {
          potential = potentials[i];
          if (potential.getOperator() === "/") {
            divideIndex = i;
            break;
          }
        }
        index = -1;
        if (divideIndex >= 0 && Math.random() <= this.settings.divideChance) {
          index = divideIndex;
        } else {
          index = rrange(0, potentials.length);
        }
        operatorString = potentials[index].getOperator();
        if (potentials[index].hasRange()) {
          operand = potentials[index].getRange().getRandomContainedValue();
        } else {
          operand = potentials[index].getValueList()[rrange(0, potentials[index].getValueList().length)];
        }
        reverseValue = this.performInverseOperationFromString(value, operatorString, operand);
        return [true, operatorString, operand, reverseValue];
      } else {
        return [false];
      }
    };

    ChalkboardChallenge.prototype.performOperationFromString = function(operand1, operatorString, operand2) {
      switch (operatorString) {
        case "+":
          return operand1 + operand2;
        case "-":
          return operand1 - operand2;
        case "x":
          return operand1 * operand2;
        case "/":
          return operand1 / operand2;
        default:
          return 0;
      }
    };

    ChalkboardChallenge.prototype.performInverseOperationFromString = function(operand1, operatorString, operand2) {
      switch (operatorString) {
        case "+":
          return operand1 - operand2;
        case "-":
          return operand1 + operand2;
        case "x":
          return operand1 / operand2;
        case "/":
          return operand1 * operand2;
        default:
          return 0;
      }
    };

    ChalkboardChallenge.prototype.findAddRange = function(value, range) {
      return this.findOperandRange(value - range.max, value - range.min, new IntegerRange(this.settings.getMinimumAddSubtractValue(), this.settings.getMaximumAddSubtractValue()));
    };

    ChalkboardChallenge.prototype.findSubRange = function(value, range) {
      return this.findOperandRange(range.min - value, range.max - value, new IntegerRange(this.settings.getMinimumAddSubtractValue(), this.settings.getMaximumAddSubtractValue()));
    };

    ChalkboardChallenge.prototype.findDivRange = function(value, range) {
      return this.findOperandRange(Math.ceil(range.min / value), Math.floor(range.max / value), new IntegerRange(this.settings.getMinimumMultiplyDivideValue(), this.settings.getMaximumMultiplyDivideValue()));
    };

    ChalkboardChallenge.prototype.findOperandRange = function(min, max, range) {
      if (min > range.max || max < range.min) {
        return new IntegerRange(-1, -1);
      } else {
        return new IntegerRange(min > range.min ? min : range.min, max < range.max ? max : range.max);
      }
    };

    ChalkboardChallenge.prototype.findValidMultCandidates = function(value, range) {
      var candidate, candidates, fac, multiplyDivideRange, ret, _i, _len;
      multiplyDivideRange = new IntegerRange(this.settings.getMinimumMultiplyDivideValue(), this.settings.getMaximumMultiplyDivideValue());
      candidates = this.getSetOfAllProducts(this.getFactors(value));
      ret = [];
      for (_i = 0, _len = candidates.length; _i < _len; _i++) {
        candidate = candidates[_i];
        fac = value / candidate;
        if (fac === Math.floor(fac) && multiplyDivideRange.containsValue(candidate) && range.containsValue(fac)) {
          ret.push(candidate);
        }
      }
      return ret;
    };

    ChalkboardChallenge.prototype.getFactors = function(value) {
      if (value === 1) {
        return [];
      } else {
        return this.getFactorsHelper(value);
      }
    };

    ChalkboardChallenge.prototype.getFactorsHelper = function(value) {
      var endIndex, factor, i, newValue, pr, ret, v, _i, _j, _len, _ref, _ref1;
      if (this.isPrimeNumber(value)) {
        return [value];
      } else {
        endIndex = this.findNearestPrimesIndex(Math.round(Math.sqrt(value)));
        newValue = 0;
        for (i = _i = 0, _ref = endIndex - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; i = 0 <= _ref ? ++_i : --_i) {
          pr = this.settings.primes[i];
          v = value / pr;
          if (v === Math.floor(v)) {
            newValue = v;
            ret = [pr];
            _ref1 = this.getFactorsHelper(newValue);
            for (_j = 0, _len = _ref1.length; _j < _len; _j++) {
              factor = _ref1[_j];
              ret.push(factor);
            }
            return ret;
          }
        }
      }
      return [];
    };

    ChalkboardChallenge.prototype.getSetOfAllProducts = function(values) {
      var i, j, products, value, _i, _j, _k, _len, _ref, _ref1, _ref2;
      products = [];
      for (_i = 0, _len = values.length; _i < _len; _i++) {
        value = values[_i];
        products.push(value);
      }
      for (i = _j = 0, _ref = values.length - 2; 0 <= _ref ? _j <= _ref : _j >= _ref; i = 0 <= _ref ? ++_j : --_j) {
        for (j = _k = _ref1 = i + 1, _ref2 = values.length - 1; _ref1 <= _ref2 ? _k <= _ref2 : _k >= _ref2; j = _ref1 <= _ref2 ? ++_k : --_k) {
          products.push(values[i] * values[j]);
        }
      }
      return products;
    };

    ChalkboardChallenge.prototype.findNearestPrimesIndex = function(value) {
      var end, middle, start;
      start = 0;
      end = this.settings.primes.length - 1;
      middle = 0;
      while (true) {
        if (start + 1 === end) {
          if (value === this.settings.primes[end]) {
            return end;
          } else {
            return start;
          }
        } else {
          middle = Math.round((start + end) / 2);
          if (value > this.settings.primes[middle]) {
            start = middle;
          } else {
            end = middle;
          }
        }
      }
      return 0;
    };

    ChalkboardChallenge.prototype.isPrimeNumber = function(value) {
      var end, i, start, v;
      start = 0;
      end = this.settings.primes.length - 1;
      while (start < end - 1) {
        i = Math.floor((end - start) / 2) + start;
        v = this.settings.primes[i];
        if (value === v) {
          return true;
        } else if (value < v) {
          end = i;
        } else if (value > v) {
          start = i;
        }
      }
      return false;
    };

    ChalkboardChallenge.prototype.calculateOperatorCount = function(level, left, streakCount) {
      var opCount, opFraction;
      opCount = level.getOperatorCount(left);
      opFraction = opCount - Math.floor(opCount);
      if (opFraction > 0.3 && opFraction < 0.5) {
        return (streakCount === 1 || streakCount === 3 ? Math.ceil(opCount) : Math.floor(opCount));
      } else if (opFraction > 0.7 && opFraction < 0.9) {
        return (streakCount === 2 ? Math.floor(opCount) : Math.ceil(opCount));
      }
      return opCount;
    };

    return ChalkboardChallenge;

  })(this.Game);

}).call(this);
