// Generated by CoffeeScript 1.7.1
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.require("src/Game/Base/GameModel.js");

  this.ChalkboardChallengeModel = (function(_super) {
    __extends(ChalkboardChallengeModel, _super);

    function ChalkboardChallengeModel(settings) {
      this.settings = settings;
      ChalkboardChallengeModel.__super__.constructor.call(this);
      this.score = 0;
      this.consecutiveCorrectCount = 0;
      this.maximumConsecutiveCorrectCount = 0;
      this.totalResponses = 0;
      this.totalCorrectResponses = 0;
      this.lastAnswerTime = 0;
      this.averageReactionTime = 0.0;
      this.scoreMultiplierIndex = 0;
      this.levelNumber = 0;
      this.leftValue = 0;
      this.rightValue = 0;
      this.leftEquation = "";
      this.rightEquation = "";
      this.streakCount = 0;
      this.blockingInput = false;
      this.trialType = "equals";
      this.lastLeftValue = 0;
      this.lastRightValue = 0;
      this.lastAnswerWasCorrect = false;

      // IVY: For the first pass at the fit test tutorial, we want to just show the how to play slides.
      // Circumventing the shared logic a bit to support.
      this.fitTestDidOpenHowToPlayOnStart = false;
    }

    ChalkboardChallengeModel.prototype.exportResults = function() {
      var stats;
      stats = {
        problems: this.totalCorrectResponses,
        total: this.totalResponses
      };
      return ChalkboardChallengeModel.__super__.exportResults.call(this, stats, "problems");
    };

    ChalkboardChallengeModel.prototype.getChalkboardChallengeGameResultMetadata = function() {
      return null;
    };

    ChalkboardChallengeModel.prototype.getCurrentChalkboardChallengeGameResultTrialMetadata = function() {
      return null;
    };

    ChalkboardChallengeModel.prototype.finishCurrentTrial = function() {};

    ChalkboardChallengeModel.prototype.startNextTrial = function() {};

    ChalkboardChallengeModel.prototype.setLeftValue = function(value) {
      this.lastLeftValue = this.leftValue;
      return this.leftValue = value;
    };

    ChalkboardChallengeModel.prototype.setRightValue = function(value) {
      this.lastRightValue = this.rightValue;
      return this.rightValue = value;
    };

    ChalkboardChallengeModel.prototype.setConsecutiveCorrectCount = function(count) {
      this.consecutiveCorrectCount = count;
      if (count > this.maximumConsecutiveCorrectCount) {
        return this.maximumConsecutiveCorrectCount = count;
      }
    };

    ChalkboardChallengeModel.prototype.setAverageReactionTime = function(time) {
      return this.averageReactionTime = time;
    };

    ChalkboardChallengeModel.prototype.accuracy = function() {
      if (this.totalResponses <= 0) {
        return 0;
      } else {
        return this.totalCorrectResponses / this.totalResponses;
      }
    };

    return ChalkboardChallengeModel;

  })(this.GameModel);

}).call(this);
