// Generated by CoffeeScript 1.7.1
(function() {
  var ChalkboardChallengeLevelSettings, JSON, lumosity,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.require("src/Game/Base/GameSettings.js");

  lumosity = this.lumosity;

  JSON = this.JSON;

  ChalkboardChallengeLevelSettings = (function() {
    function ChalkboardChallengeLevelSettings(dict) {
      var _ref, _ref1;
      if ('operatorCount' in dict) {
        this.operatorCountLeft = dict.operatorCount.left;
        this.operatorCountRight = dict.operatorCount.right;
      } else {
        this.operatorCountLeft = 0;
        this.operatorCountRight = 0;
      }
      this.maximumDifference = (_ref = dict.maximumDifference) != null ? _ref : 0;
      this.operatorKey = (_ref1 = dict.ops) != null ? _ref1 : "";
    }

    ChalkboardChallengeLevelSettings.prototype.getOperatorCount = function(left) {
      if (left) {
        return this.operatorCountLeft;
      } else {
        return this.operatorCountRight;
      }
    };

    ChalkboardChallengeLevelSettings.prototype.getMaximumDifference = function() {
      return this.maximumDifference;
    };

    ChalkboardChallengeLevelSettings.prototype.getOperatorKey = function() {
      return this.operatorKey;
    };

    return ChalkboardChallengeLevelSettings;

  })();

  this.ChalkboardChallengeSettings = (function(_super) {
    __extends(ChalkboardChallengeSettings, _super);

    function ChalkboardChallengeSettings() {
      var level;
      ChalkboardChallengeSettings.__super__.constructor.call(this, "settings.json");
      this.parsedLevels = (function() {
        var _i, _len, _ref, _results;
        _ref = this.levels;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          level = _ref[_i];
          _results.push(new ChalkboardChallengeLevelSettings(level));
        }
        return _results;
      }).call(this);
      if (this.secondsAddedOnNewLevel == null) {
        this.secondsAddedOnNewLevel = 10;
      }
      if (this.secondsAddedOnIncorrect == null) {
        this.secondsAddedOnIncorrect = -3;
      }
      if (this.trialTypeLessThanChance == null) {
        this.trialTypeLessThanChance = 0.45;
      }
      this.operatorToVisual = {};
      this.operatorToVisual[this.operators.all[0]] = this.operatorVisuals.all[0];
      this.operatorToVisual[this.operators.all[1]] = this.operatorVisuals.all[1];
      this.operatorToVisual[this.operators.all[2]] = this.operatorVisuals.all[2];
      this.operatorToVisual[this.operators.all[3]] = this.operatorVisuals.all[3];
      this.operatorToANSI = {};
      this.operatorToANSI[this.operatorVisuals.all[0]] = this.operatorsANSI[0];
      this.operatorToANSI[this.operatorVisuals.all[1]] = this.operatorsANSI[1];
      this.operatorToANSI[this.operatorVisuals.all[2]] = this.operatorsANSI[2];
      this.operatorToANSI[this.operatorVisuals.all[3]] = this.operatorsANSI[3];
      this.operatorRegExp = new RegExp('[\\' + this.operatorVisuals.all.join('\\') + ']', 'g');
    }

    // IVY: For the first pass at the fit test tutorial, we want to just show the how to play slides.
    // Circumventing the shared logic a bit to support.
    ChalkboardChallengeSettings.prototype.shouldShowHowToPlayOnStart = function(){
      var retval = false;
      if( lumosity.game.params )
      {
        if( lumosity.game.params.fit_test_mode === "true" || lumosity.game.params.fit_test_mode === true )
        {
          retval = true;
        }
        else if( lumosity.game.params.how_to_play === "true" || lumosity.game.params.how_to_play === true ) 
        {
            retval = true;
        }
      }
      return retval;
    };

    ChalkboardChallengeSettings.prototype.getOperatorCount = function(operatorKey) {
      return this.operators[operatorKey].length;
    };

    ChalkboardChallengeSettings.prototype.getOperatorAt = function(operatorKey, index) {
      return this.operators[operatorKey][index];
    };

    ChalkboardChallengeSettings.prototype.getOperatorVisualAt = function(operatorKey, index) {
      return this.operatorVisuals[operatorKey][index];
    };

    ChalkboardChallengeSettings.prototype.getOperatorCountForShortVisuals = function() {
      var _ref;
      return (_ref = this.operatorCountForShortVisuals) != null ? _ref : 0;
    };

    ChalkboardChallengeSettings.prototype.getLevelCount = function() {
      return this.levels.length;
    };

    ChalkboardChallengeSettings.prototype.getLevelAt = function(index) {
      return this.parsedLevels[index];
    };

    ChalkboardChallengeSettings.prototype.getDefaultMinimumValue = function() {
      var _ref;
      return (_ref = this.defaultValueRange[0]) != null ? _ref : 0;
    };

    ChalkboardChallengeSettings.prototype.getMinimumAddSubtractValue = function() {
      var _ref;
      return (_ref = this.addSubtractRange[0]) != null ? _ref : 0;
    };

    ChalkboardChallengeSettings.prototype.getMaximumAddSubtractValue = function() {
      var _ref;
      return (_ref = this.addSubtractRange[1]) != null ? _ref : 0;
    };

    ChalkboardChallengeSettings.prototype.getMinimumMultiplyDivideValue = function() {
      var _ref;
      return (_ref = this.multiplyDivideRange[0]) != null ? _ref : 0;
    };

    ChalkboardChallengeSettings.prototype.getMaximumMultiplyDivideValue = function() {
      var _ref;
      return (_ref = this.multiplyDivideRange[1]) != null ? _ref : 0;
    };

    return ChalkboardChallengeSettings;

  })(this.GameSettings);

}).call(this);
