// Generated by CoffeeScript 1.7.1
(function() {
  var cc,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.require("src/Game/Base/GameView.js");

  this.require("src/Game/Widget/GameWidgetFeedback.js");

  this.require("src/Game/Widget/GameWidgetHud.js");

  cc = this.cc;

  this.ChalkboardChallengeView = (function(_super) {
    __extends(ChalkboardChallengeView, _super);

    function ChalkboardChallengeView(screenSize, settings, model, interactionResponder, preload) {
      this.screenSize = screenSize;
      this.settings = settings;
      this.interactionResponder = interactionResponder;
      ChalkboardChallengeView.__super__.constructor.call(this, this.screenSize, this.settings, model, this.interactionResponder, preload);
      this.hasPreviousValue = false;
      this.streakDotFullViews = [this.answerBlank1, this.answerBlank2, this.answerBlank3, this.answerBlank4, this.answerBlank5];
      this.setScore(0);
      this.setStreakNumber(0);
      this.feedback = this.getFeedbackWidget();
      this.baseFeedbackPosition = this.feedback.getPosition();
      this.baseFeedbackScale = this.feedback.getScale();
      this.feedbackAnimationPlaying = false;
      this.topCardText.adjustsFontSizeToFitWidth = true;
      this.bottomCardText.adjustsFontSizeToFitWidth = true;

      this.positionPromptLabel();
    }

    ChalkboardChallengeView.prototype.resetTextColor = function() {
        this.topCardText.setColor(this.correctColor);
        this.bottomCardText.setColor(this.correctColor);
    };

    ChalkboardChallengeView.prototype.layout_readingData = function(name, data) {
      switch (name) {
        case "equalButtonText":
          this.equalButtonSize = data.textData.size;
          this.equalButtonFace = LumosityUtils.getFontLocation(data.textData.face);
          return this.equalButtonColor = cc.c4b(data.textData.color.Red, data.textData.color.Green, data.textData.color.Blue, data.textData.color.Alpha);
        case "incorrectTextHighlight":
          return this.incorrectColor = cc.c4b(data.textData.color.Red, data.textData.color.Green, data.textData.color.Blue, data.textData.color.Alpha);
        case "topCardText":
          return this.correctColor = cc.c4b(data.textData.color.Red, data.textData.color.Green, data.textData.color.Blue, data.textData.color.Alpha);
      }
    };

    ChalkboardChallengeView.prototype.layout_settingNodeFlags = function( nodeName, nodeData, node )
    {
        var nodeFlags = ChalkboardChallengeView.__super__.layout_settingNodeFlags.call( nodeName, nodeData, node );
        if( nodeName === "promptContainer" )
        {
            nodeFlags &= ~( LayoutNodeFlags.RootScale );
        }

        return nodeFlags;
    };

    ChalkboardChallengeView.prototype.layout_creatingNode = function(name, data) {
      var result, _ref, _ref1, _ref2;
      this.layout_readingData(name, data);
      result = ChalkboardChallengeView.__super__.layout_creatingNode.call(this, name, data);
      if (result) {
        return result;
      }
      switch (name) {
        case "topCardButton":
          return this._createButton("cardTrayUp.png", "cardTrayDown.png", "buttonLeft");
        case "topCard":
          return this._createSprite("chalkboardCard.png");
        case "bottomCardButton":
          return this._createButton("cardTrayUp.png", "cardTrayDown.png", "buttonRight");
        case "bottomCard":
          return this._createSprite("chalkboardCard.png");
        case "equalButton":
          return this._createButton("chalkboardEqualUp.png", "chalkboardEqualDown.png", "buttonEqual", localize("equal", "EQUAL"), (_ref = this.equalButtonFace) != null ? _ref : LumosityUtils.getFontLocation("MuseoSans-500"), (_ref1 = this.equalButtonSize) != null ? _ref1 : 54, (_ref2 = this.equalButtonColor) != null ? _ref2 : cc.c4b(47, 190, 234, 255), cc.c4b(255, 255, 255, 255), data.size);
        case "answerBlank1":
          return this.createAnswerSlot();
        case "answerBlank2":
          return this.createAnswerSlot();
        case "answerBlank3":
          return this.createAnswerSlot();
        case "answerBlank4":
          return this.createAnswerSlot();
        case "answerBlank5":
          return this.createAnswerSlot();
        default:
          return null;
      }
    };

    ChalkboardChallengeView.prototype.enableButtons = function(isEnabled) {
      this.topCardButton.setEnabled(isEnabled);
      this.bottomCardButton.setEnabled(isEnabled);
      return this.equalButton.setEnabled(isEnabled);
    };

    ChalkboardChallengeView.prototype.createAnswerSlot = function() {
      var result;
      result = this._createSprite("answerBlank.png");
      result.fill = cc.Sprite.create("answerFill.png");
      result.fill.setAnchorPoint(cc.p(0, 0));
      result.addChild(result.fill);
      return result;
    };

    ChalkboardChallengeView.prototype.setTextAccent = function(swapped) {
      if (swapped) {
        this.topCardText.setColor(this.incorrectColor);
        return this.bottomCardText.setColor(this.incorrectColor);
      } else {
        this.topCardText.setColor(this.correctColor);
        return this.bottomCardText.setColor(this.correctColor);
      }
    };

    ChalkboardChallengeView.prototype.playFeedbackAnimation = function(n) {
      var animName, targetNode;
      if (n === 0) {
        this.setStreakNumber(0);
        return;
      }
      if (n > 5) {
        n = 5;
      }
      animName = "feedback" + n;
      targetNode = this["answerBlank" + n];
      this.playAnimation(animName);
      this.targetPosition = LumosityUtils.convertPointSpace(targetNode.getPosition(), targetNode.getParent(), this.feedback.getParent());
      this.targetDuration = this.animationController.getDuration(animName);
      this.targetTime = 0.0;
      this.feedback.setPosition(this.baseFeedbackPosition);
      this.feedback.setScale(this.baseFeedbackScale, this.baseFeedbackScale);
      return this.feedbackAnimationPlaying = true;
    };

    ChalkboardChallengeView.prototype.tickFeedbackAnimation = function(dt) {
      var posProgress, progress, revProgress;
      if (!this.feedbackAnimationPlaying) {
        return;
      }
      this.targetTime += dt;
      if (this.targetTime < 0.5 * this.targetDuration) {
        this.feedback.setPosition(this.baseFeedbackPosition);
        return this.feedback.setScale(this.baseFeedbackScale, this.baseFeedbackScale);
      } else if (this.targetTime < this.targetDuration) {
        progress = 2.0 * (this.targetTime / this.targetDuration - 0.5);
        progress = Math.pow(progress, 1.5);
        revProgress = 1.0 - 0.5 * progress;
        posProgress = Math.min(1.0, 1.2 * progress);
        this.feedback.setScale(revProgress * this.baseFeedbackScale, revProgress * this.baseFeedbackScale);
        return this.feedback.setPosition(this.baseFeedbackPosition.x + posProgress * (this.targetPosition.x - this.baseFeedbackPosition.x), this.baseFeedbackPosition.y + posProgress * (this.targetPosition.y - this.baseFeedbackPosition.y));
      } else {
        this.feedback.setPosition(this.baseFeedbackPosition);
        this.feedback.setScale(0, 0);
        return this.feedbackAnimationPlaying = false;
      }
    };

    ChalkboardChallengeView.prototype.showNewValue = function(left, right) {
      if (this.topCardText) {
        this.topCardText.setString(left);
      }
      if (this.bottomCardText) {
        this.bottomCardText.setString(right);
      }
      return this.hasPreviousValue = true;
    };

    ChalkboardChallengeView.prototype.setAnswers = function(left, right) {
      if (this.topCardText) {
        this.topCardText.setString(left);
      }
      if (this.bottomCardText) {
        return this.bottomCardText.setString(right);
      }
    };

    ChalkboardChallengeView.prototype.setStreakNumber = function(number) {
      var i, spr, _i, _len, _ref, _results;
      _ref = this.streakDotFullViews;
      _results = [];
      for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
        spr = _ref[i];
        _results.push(spr.fill.setVisible(i < number));
      }
      return _results;
    };

    ChalkboardChallengeView.prototype.setLevel = function(level) {};

    ChalkboardChallengeView.prototype.setWhichIsLargerVisible = function(visible) {
      if (!("whichIsLargerLabel" in this)) {
        return;
      }
      return whichIsLargerLabel.setVisible(visible);
    };

    ChalkboardChallengeView.prototype.setHighlightedTimeHud = function(highlighted) {
      if (this.hudTime) {
        return this.hudTime.setOpacity((highlighted ? 0.3 : 0));
      }
    };

    ChalkboardChallengeView.prototype.setHighlightedTimeHud = function(highlighted) {
      var hudWidget;
      if (this._widgets) {
        hudWidget = this._widgets[GameWidgetHud.prototype.getType()];
        if (hudWidget) {
          return hudWidget.setTimeHighlighted(highlighted);
        }
      }
    };

    ChalkboardChallengeView.prototype.showStimuliImmediately = function() {
      if (this.leftEquation) {
        this.leftEquation.setOpacity(1);
        this.leftEquation.setVisible(true);
      }
      if (this.rightEquation) {
        this.rightEquation.setOpacity(1);
        return this.rightEquation.setVisible(true);
      }
    };

    ChalkboardChallengeView.prototype.fadeOutStimuli = function(duration) {
      this.stopAnimation("problemSolvedCorrect");
      this.stopAnimation("problemSolvedIncorrect");
      if (this.leftEquation) {
        this.leftEquation.setOpacity(0);
      }
      if (this.rightEquation) {
        this.rightEquation.setOpacity(0);
      }
      if (this.leftAnswer) {
        this.leftAnswer.setOpacity(0);
      }
      if (this.rightAnswer) {
        return this.rightAnswer.setOpacity(0);
      }
    };

    ChalkboardChallengeView.prototype.setExtraTimeChange = function(amount) {
      var labelValue, seconds;
      seconds = localize("timeAddedSuffix", "seconds");
      labelValue = amount > 0 ? "+ " + amount + " " + seconds : "- " + (-amount) + " " + seconds;
      if (this.chalkboardTimeBonus) {
        return this.chalkboardTimeBonus.setString(labelValue);
      }
    };

    ChalkboardChallengeView.prototype.onGameBeginAnimationFinished = function() {};

    ChalkboardChallengeView.prototype.positionPromptLabel = function()
    {
      var hudPos = cc.PointZero();
      var topCardTopPosY = 0;
      var topCardTopPos = cc.PointZero();
      var promptContainerPos = cc.PointZero();
      var promptContainerPosY = 0;

      // Get the huds position
      hudPos = LumosityUtils.convertPointSpace( cc.p( 0, 0 ), this.topUI, this.gameContent );

      // Get the top position of the top card.
      topCardTopPosY = this.topCard.getPosition().y + ( ( this.topCard.getContentSize().height * this.topCard.getScaleY() ) * this.topCard.getAnchorPoint().y );
      topCardTopPos = cc.p( 0, topCardTopPosY );

      // Get the prompt container's position.
      promptContainerPos = LumosityUtils.convertPointSpace( this.promptContainer.getPosition(), this._gameStage, this.gameContent );
      this.promptContainer.removeFromParent( false );
      this.gameContent.addChild( this.promptContainer );

      // Set prompt container to be in between the hud and the top card.
      promptContainerPosY = ( ( hudPos.y - topCardTopPos.y ) * .25 ) + topCardTopPos.y;
      this.promptContainer.setPosition( cc.p( promptContainerPos.x, promptContainerPosY ) );

      // Re-adjust the dimension size.
      this.prompt.setDimensions( cc.size( this.prompt.getContentSize().width, 0 ) );
      // Disable positioning from the animation controller.
      AnimationChanges.addNodeIgnoredChanges( this.promptContainer, [ AnimationChanges.Position ] );
    };

    return ChalkboardChallengeView;

  })(this.GameView);

}).call(this);
