/*global cc*/
/*global require*/

var PlannerNode;
( function()
{
    "use strict";
    
    PlannerNode = cc.Class.extend(
    {   
        x: 0,
        y: 0,
        heuristicCost: 0,
        parent: null,
        hashTableNext: null,

        /** @lends PlannerNode.prototype */
        
        /**
         *  PlannerNode is the main class for a Planner Node!
         *
         *  @constructs
         */
        ctor: function( x, y, parent )
        {
            this.x = x;
            this.y = y;
            this.parent = parent;
        },

        compaireBestFirst: function( second )
        {
            if(this.heuristicCost > second.heuristicCost)
            {
                return 1;
            }
            else if(this.heuristicCost < second.heuristicCost)
            {
                return -1;
            }
    
            // Not greater than or less than, must be equal
            return 0;
        },

        computeHeuristicCost: function( goalX, goalY )
        {
            // Basic distance formula
            var tempHC = ( ( goalX - this.x ) * ( goalX - this.x ) ) +
                         ( ( goalY - this.y ) * ( goalY - this.y ) );
            
            this.heuristicCost = Math.sqrt( tempHC );
        }
    } );
}() );
