/*global cc*/
/*global require*/

require( "src/Animation/PropertyAnimator.js" );
/*global PropertyAnimator*/

var SkewAnimator;
(function()
{
    "use strict";
    
    SkewAnimator = PropertyAnimator.extend(
    {
        /** @lends SkewAnimator.prototype */
        
        /**
         * An SkewAnimator will animate skew changes on a node.
         *
         * @constructs
         */
        ctor: function()
        {
            this._super( "SkewTo" );
        },
        
        _setFunction: function( node, value )
        {
            node.setSkewX( value.x );
            node.setSkewY( value.y );
        },
        
        /**
         * Since we need to pass in multiple parameters to SkewTo (for x and y), we've overridden this.
         */
        _createAnimationAction: function( duration, endValue )
        {
            return cc.SkewTo.create( duration, endValue.x, endValue.y );
        }
    });
}() );