/*jslint node: true */
"use strict";


var DebugMenu = cc.Class.extend(
{
    /**
     * @param   controller  Game that has model and view property.
     */
    ctor: function(controller)
    {
        this.controller = controller;
        this._addDebugMenuButtons(controller.view);
    },

    _addDebugMenuButtons: function(view)
    {
        view.addDebugMenuButton( { labelText: "4 trials", 
            callback: function(){this._trials(4)}, 
            target: this, closeMenuOnCallback: true } );
        view.addDebugMenuButton( { labelText: "1 trial", 
            callback: function(){this._trials(1)}, 
            target: this, closeMenuOnCallback: true } );  
        view._createUserLevelDebugButtons();                         
    },

    _trials: function(num_trials)
    {
        this.controller.settings.getGameLengthInTrials = function ( isFitTestMode ) {
            return num_trials;
        };
        this.controller.onRestart();
    }
});
