/*global require*/
/*global cc*/
/*global lumosity*/


require( "jsb.js" );
require( "src/Utility/LumosityGlobals.js" );
/*global LumosityGlobals*/
require( "src/Utility/LumosityLogger.js" );
/*global ll*/
require( "src/Utility/LumosityUtils.js" );
/*global LumosityUtils*/
require( "src/MainScene.js" );
/*global MainScene*/

ll.verbose("device: " + lumosity.device.id);
ll.verbose("slug: " + lumosity.game.slug);
ll.verbose("path: " + lumosity.game.path);
ll.verbose("params: " + JSON.stringify(lumosity.game.params));

// boot code needed for cocos2d + JS bindings.
// Not needed by cocos2d-html5

function configureScaling()
{
	var eglView = cc.EGLView.getInstance();
    var screenSize = cc.Director.getInstance().getWinSize();
    eglView.setDesignResolutionSize( screenSize.width, screenSize.height, cc.RESOLUTION_POLICY.SHOW_ALL );
}

cc.dumpConfig();

configureScaling();

var director = cc.Director.getInstance();
director.setDisplayStats( false );

// set FPS. the default value is 1.0 / 60 if you don't call this
director.setAnimationInterval( 1.0 / 60 );

// create a scene. it's an autorelease object
var mainScene = new MainScene( this );

// run
director.runWithScene( mainScene );