// Generated by CoffeeScript 1.6.3
(function() {
  var JSON, SpeedMatchTrial, cc, lumosity,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.require("src/Game/Base/GameSettings.js");

  lumosity = this.lumosity;

  JSON = this.JSON;

  cc = this.cc;

  SpeedMatchTrial = (function() {
    function SpeedMatchTrial(name, settings) {
      var key, val;
      this.name = name;
      this.symbolIds = [];
      this.symbols = {};
      for (key in settings) {
        val = settings[key];
        this.addSymbol(key, val);
      }
    }

    SpeedMatchTrial.prototype.getName = function() {
      return this.name;
    };

    SpeedMatchTrial.prototype.setName = function(name) {
      return this.name = name;
    };

    SpeedMatchTrial.prototype.getSymbolIds = function() {
      return this.symbolIds;
    };

    SpeedMatchTrial.prototype.addSymbol = function(symbolId, imageFileName) {
      if (this.getSymbolImageFileName(symbolId) !== "") {
        cc.log("Attempt to add duplicate trial symbol " + symbolId + " to trial " + this.name + ", skipping");
        return;
      }
      this.symbolIds.push(symbolId);
      return this.symbols[symbolId] = imageFileName;
    };

    SpeedMatchTrial.prototype.getSymbolImageFileName = function(symbolId) {
      if (symbolId in this.symbols) {
        return this.symbols[symbolId];
      } else {
        return "";
      }
    };

    return SpeedMatchTrial;

  })();

  this.SpeedMatchSettings = (function(_super) {
    __extends(SpeedMatchSettings, _super);

    function SpeedMatchSettings() {
      var key, trials, val;
      SpeedMatchSettings.__super__.constructor.call(this, "settings.json");
      this.trialIds = [];
      trials = this.trials;
      for (key in trials) {
        val = trials[key];
        this.trialIds.push(key);
        this.trials[key] = new SpeedMatchTrial(key, val);
      }
      if (this.bonusMultipliers.length === 0) {
        this.bonusMultipliers.push(1);
      }
    }

    return SpeedMatchSettings;

  })(this.GameSettings);

}).call(this);
