/*global cc*/
/*global require*/

require( "src/Animation/PropertyAnimator.js" );
/*global PropertyAnimator*/

require( "src/Animation/LayoutLoader.js" );
/*global LayoutLoader*/

var ScaleAnimator;
(function()
{
    "use strict";
    
    ScaleAnimator = PropertyAnimator.extend(
    {
        /** @lends ScaleAnimator.prototype */
        
        /**
         * An ScaleAnimator will animate position changes on a node.
         *
         * @constructs
         */
        ctor: function( globalScale )
        {
            this._super( "ScaleTo" );
            
            this.globalScale = globalScale;
        },
        
        _convertDesignValueToGameValue: function( designValue, node )
        {
            return LayoutLoader.convertDesignSizeToWorldScale( node, designValue, this.globalScale );
        },
        
        _setFunction: function( node, value )
        {
            node.setScaleX( value.x );
            node.setScaleY( value.y );
        },
        
        //must override because ScaleTo expects 2 params
        _createAnimationAction: function( duration, endValue )
        {
            return cc.ScaleTo.create( duration, endValue.x, endValue.y );
        }
    });
}() );