/*global cc*/
/*global require*/

require( "src/Animation/PropertyAnimator.js" );
/*global PropertyAnimator*/

var VisibleAnimator;
(function()
{
    "use strict";
    
    VisibleAnimator = PropertyAnimator.extend(
    {
        /** @lends VisibleAnimator.prototype */        
        
        /**
         * An VisibleAnimator will animate visibility changes on a node. Note this can only set
         * a value, you cannot animate visibility.
         *
         * @constructs
         */
        ctor: function()
        {
            this._super( "" );
        },
        
        /**
         * You cannot animate visibility, so this does nothing.
         */
        addAnimateProperty:function( prevSequence, node, endValue, duration, easeType, timeStarted )
        {
            return undefined;
        },
        
        _convertDesignValueToGameValue: function( designValue )
        {
            var value = designValue;
            
            if ( value === "true" )
            {
                value = true;
            }
            else if ( value === "false" )
            {
                value = false;
            }
            
            return !!value;
        },
        
        _setFunction: function( node, value )
        {
            node.setVisible( value );
        }
    });
}() );