#!/usr/bin/python

import sys, os
from PIL import Image

def importSpriteSheet(path):
	# load image
	im = Image.open(path)
	if im.mode != 'RGBA': im = im.convert('RGBA')
	
	# iterate over 80x80 frames
	w,h = im.size
	assert h == 80
	frames = ( im.crop((80*i, 0, 80*i+80, 80)) for i in xrange(w // 80) )
	for i,frame in enumerate(frames):
		
		frame.save('../../TrainFrames/TrainFrame_%d.png' % i)


if __name__ == '__main__':
	if len(sys.argv) == 1:
		importSpriteSheet('/Volumes/Peashooter/src/flash_games/resources/3d/RailroadSwitch/TravellerSprites.png')
	else:
		importSpriteSheet(sys.argv[1])