#!/usr/bin/python

import sys, os

def importData(path):
	# result will contains the final strings
	result = ['"boards": [', '\t[']
	currDatum = []
	paragraphCount = 0
	with open(path, 'r') as f:
		for line in f:
			data = line.strip()
			if data:
				# append the line
				currDatum.append('\t\t"%s"' % data)
			else:
				# begin a new "paragraph" when we encounter empty lines
				paragraphCount += 1
				result.append(',\n'.join(currDatum))
				result.append('\t],')
				result.append('\t[')
				currDatum = []
	# finish current paragraph
	if currDatum:
		paragraphCount += 1
		result.append(',\n'.join(currDatum))
	else:
		result = result[:-2]
	# clean up
	result.append("\t]\n]")

	# print to console
	print "\n".join(result)

	#print "Paragraph Count %s" % paragraphCount


if __name__ == '__main__':
	if len(sys.argv) == 1:
		importData('/Volumes/Peashooter/src/flash_games/src/as3/com/lumoslabs/games/railroadSwitch/tile_trees.txt')
	else:
		importData(sys.argv[1])