// Generated by CoffeeScript 1.7.1
(function() {
  var JSON, lumosity, tt,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.require("src/Game/TrainOfThoughtUtil.js");

  this.require("src/Game/Base/GameSettings.js");

  tt = this.TrainOfThoughtUtil;

  lumosity = this.lumosity;

  JSON = this.JSON;


  /**
   * The Train of Thought settings.
   * @class
   * @name TrainOfThoughtSettings
   */

  this.TrainOfThoughtSettings = (function(_super) {
    __extends(TrainOfThoughtSettings, _super);


    /**
    	* @constructor
     */

    function TrainOfThoughtSettings() {
      var key, settingsString, val, _ref;
      TrainOfThoughtSettings.__super__.constructor.call(this, "settings.json");
      settingsString = lumosity.io_read("graphics_settings.json");
      _ref = JSON.parse(settingsString, null);
      for (key in _ref) {
        val = _ref[key];
        this[key.charAt(0).toLowerCase() + key.substring(1)] = val;
      }

      this.showScore = false; // this is because we have a custom spaced "correct" widget
    }


    /**
     * get the asset name for the given destination ID
     * Unfortunately, Destination0 images are out of order.
     *
     * @param i - the index of the destination, [0,destinationCount)
     */
    TrainOfThoughtSettings.prototype.getDestinationName = function(i) {
      return "Destination" + this.destinationsInOrder[i];
    };


    /**
    	* Get the position and rotate of the given waypoint animation at
    	* a given amount of progress
    	* @method
    	* @name getTravellerPositionRotation
    	* @param name - the name of the waypoint
    	* @param u - the progress, [0,1)
     */

    TrainOfThoughtSettings.prototype.getTravellerPositionRotation = function(name, u) {
      var idx, len, li;
      if (u >= 1.0) {
        u = 0.99999;
      }
      li = this.travellerData[name];
      len = li.length / 3;
      idx = Math.floor(u * len);
      return {
        x: li[3 * idx],
        y: li[3 * idx + 1],
        r: li[3 * idx + 2]
      };
    };

    return TrainOfThoughtSettings;

  })(this.GameSettings);

}).call(this);
